// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.adagio.core.dao.data.batch;

import fr.ifremer.adagio.core.dao.Search;
import fr.ifremer.adagio.core.dao.referential.QualityFlag;
import java.util.Collection;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * Lot avec critères de classement.
 * Exemple de critères : 'Débarquement', 'Rejet', 'Vrac', 'Hors Vrac', 'Vidé/Eteté...',
 * 'Gros/Moyen/Petit'
 * @see SortingBatch
 */
public interface SortingBatchDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link SortingBatch}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of SortingBatch from the persistent store.
     * @param id
     * @return SortingBatch
     */
    public SortingBatch get(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer id);

    /**
     * Loads an instance of SortingBatch from the persistent store.
     * @param id
     * @return SortingBatch
     */
    public SortingBatch load(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer id);

    /**
     * Loads all entities of type {@link SortingBatch}.
     *
     * @return the loaded entities.
     */
    public Collection<SortingBatch> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of SortingBatch and adds it to the persistent store.
     * @param sortingBatch
     * @return SortingBatch
     */
    public SortingBatch create(SortingBatch sortingBatch);

    /**
     * <p>
     * Does the same thing as {@link #create(SortingBatch)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param sortingBatch
     * @return Object
     */
    public Object create(int transform, SortingBatch sortingBatch);

    /**
     * Creates a new instance of SortingBatch and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of SortingBatch
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<SortingBatch> create(Collection<SortingBatch> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(SortingBatch)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<SortingBatch> entities);

    /**
     * <p>
     * Creates a new <code>SortingBatch</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param samplingRatio 
     * @param samplingRatioText 
     * @param rankOrder Numéro d'ordre du lot.
Sert pour déterminer l'ordre de présentation des lots rattaché à un même lot père.
     * @param subgroupCount Nombre de sous ensembles ayant servit à la quantification. Attention : Il ne s'agit pas du nombre de
lot fils.
Par exemple il pourra s'agir d'un nombre de caisse servant à quantifié le lot.
Par exemple, pour une détermination de la quantification par les volumes :
- nombre_sous_ensembles_quantifiés = 3
- poids moyen par sous-ensemble = 5 kg
=> Poids total du lot = 3 x 5 = 15kg
     * @param individualCount Nombre d'individus comptés.
     * @param childBatchsReplication Indique si les lots fils sont des réplicats ou non. Attribut non renseigné si un des lots père est
rattaché à un taxon ou groupe de taxon.
     * @param exhaustiveInventory <html>
<head>
</head>
<body>
<p>
Indique si l'inventaire des esp&#232;ces scientifiques (ReferenceTaxon) est
exhaustif ou non.Attribut non renseign&#233; si le lot ou un de ses lots p&#232;re
est rattach&#233; &#224; un taxon.
</p>
<p>
</p>
<p>
Si l'inventaire est exhautif, il convient de remplir <i>BatchExhautiveInventory</i>,
pour tracer sur quelle liste d'esp&#232;ces porte l'exhaustivit&#233;. Si
<i>BatchExhautiveInventory</i>
n'est pas renseign&#233;, alors l'exhautivit&#233; porte sur toutes les esp&#232;ces.
</p>
</body>
</html>
     * @param comments 
     * @param label Libellé du lot (besoin pour le flux d'échantillonnage ISCAX).
Pas encore utiliser, dans Allegro V2 et V3 lot 1.
     * @param remoteId 
     * @return SortingBatch
     */
    public SortingBatch create(
        Float samplingRatio,
        String samplingRatioText,
        Short rankOrder,
        Float subgroupCount,
        Integer individualCount,
        Boolean childBatchsReplication,
        Boolean exhaustiveInventory,
        String comments,
        String label,
        Integer remoteId);

    /**
     * <p>
     * Does the same thing as {@link #create(Float, String, Short, Float, Integer, Boolean, Boolean, String, String, Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param samplingRatio 
     * @param samplingRatioText 
     * @param rankOrder Numéro d'ordre du lot.
Sert pour déterminer l'ordre de présentation des lots rattaché à un même lot père.
     * @param subgroupCount Nombre de sous ensembles ayant servit à la quantification. Attention : Il ne s'agit pas du nombre de
lot fils.
Par exemple il pourra s'agir d'un nombre de caisse servant à quantifié le lot.
Par exemple, pour une détermination de la quantification par les volumes :
- nombre_sous_ensembles_quantifiés = 3
- poids moyen par sous-ensemble = 5 kg
=> Poids total du lot = 3 x 5 = 15kg
     * @param individualCount Nombre d'individus comptés.
     * @param childBatchsReplication Indique si les lots fils sont des réplicats ou non. Attribut non renseigné si un des lots père est
rattaché à un taxon ou groupe de taxon.
     * @param exhaustiveInventory <html>
<head>
</head>
<body>
<p>
Indique si l'inventaire des esp&#232;ces scientifiques (ReferenceTaxon) est
exhaustif ou non.Attribut non renseign&#233; si le lot ou un de ses lots p&#232;re
est rattach&#233; &#224; un taxon.
</p>
<p>
</p>
<p>
Si l'inventaire est exhautif, il convient de remplir <i>BatchExhautiveInventory</i>,
pour tracer sur quelle liste d'esp&#232;ces porte l'exhaustivit&#233;. Si
<i>BatchExhautiveInventory</i>
n'est pas renseign&#233;, alors l'exhautivit&#233; porte sur toutes les esp&#232;ces.
</p>
</body>
</html>
     * @param comments 
     * @param label Libellé du lot (besoin pour le flux d'échantillonnage ISCAX).
Pas encore utiliser, dans Allegro V2 et V3 lot 1.
     * @param remoteId 
     * @return SortingBatch
     */
    public Object create(
        int transform,
        Float samplingRatio,
        String samplingRatioText,
        Short rankOrder,
        Float subgroupCount,
        Integer individualCount,
        Boolean childBatchsReplication,
        Boolean exhaustiveInventory,
        String comments,
        String label,
        Integer remoteId);

    /**
     * <p>
     * Creates a new <code>SortingBatch</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param childBatchsReplication
     * @param exhaustiveInventory
     * @param qualityFlag
     * @param rankOrder
     * @param rootBatch
     * @return SortingBatch
     */
    public SortingBatch create(
        Boolean childBatchsReplication,
        Boolean exhaustiveInventory,
        QualityFlag qualityFlag,
        Short rankOrder,
        CatchBatch rootBatch);

    /**
     * <p>
     * Does the same thing as {@link #create(Short, Boolean, Boolean)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param childBatchsReplication
     * @param exhaustiveInventory
     * @param qualityFlag
     * @param rankOrder
     * @param rootBatch
     * @return Object
     */
    public Object create(
        int transform,
        Boolean childBatchsReplication,
        Boolean exhaustiveInventory,
        QualityFlag qualityFlag,
        Short rankOrder,
        CatchBatch rootBatch);

    /**
     * Updates the <code>sortingBatch</code> instance in the persistent store.
     * @param sortingBatch
     */
    public void update(SortingBatch sortingBatch);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<SortingBatch> entities);

    /**
     * Removes the instance of SortingBatch from the persistent store.
     * @param sortingBatch
     */
    public void remove(SortingBatch sortingBatch);

    /**
     * Removes the instance of SortingBatch having the given
     * <code>identifier</code> from the persistent store.
     * @param id
     */
    public void remove(Integer id);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<SortingBatch> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<SortingBatch> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.adagio.core.dao.data.batch.SortingBatchDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.adagio.core.dao.data.batch.SortingBatchDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final SortingBatch entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,SortingBatch)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.adagio.core.dao.data.batch.SortingBatchDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,SortingBatch)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}